# micro 3D
## API 3D-рендеринга

micro 3D - это упрощенный 3D API, созданный поверх Babylon.js. В настоящее время он очень минимален, но в будущем будет развиваться. Если вы ищете стабильный, полнофункциональный  3D API, обратите внимание на Babylon.js.

## Основы

### Подключение micro 3D

После создания проекта откройте вкладку настроек, нажмите "Показать дополнительные настройки" и выберите **micro 3D** в качестве графической библиотеки.

### Сцена

Создание новой сцены:

```
scene = new M3D.Scene()
scene.setBackground("rgb(9, 0, 28)")
```

### Добавление объектов

Добавление простой коробки:

```
box = new M3D.Box()
box.position.set(0, 0, 5)
box.setColor("rgb(255, 192,0)")
scene.add(box)
```

### Добавление света

Добавление направленного света:

```
light = new M3D.DirectionalLight(new M3D.Vector3(-1, -.5, 1))
light.setColor("rgb(255,217,198)")
```

### Настройка камеры

Настройка камеры:

```
camera = new M3D.Camera()
camera.position.set(0, 0, 1)
```

### Обновление

Вы можете получить доступ к свойствам объектов в функции `update()`, чтобы заставить их вращаться в пространстве

```
update = function()
  box.rotation.x+=0.01
  box.rotation.y+=0.02
end
```

### Визуализация

В вашей функции `draw()` вызовите `screen.render`, передав вашу сцену и камеру в качестве аргументов:

```
draw = function()
  screen.render(scene, camera)
end
```

## Примеры

https://microstudio.dev/i/gilles/m3dtest/