# Урок

:project Programming

## Объекты

:overlay

:position 30,30,40,40

:navigate projects.code.console

### Объекты

Объекты в microScript можно сравнить с объектами в реальной жизни. Объект - это  структура, обладающая набором свойств. Объект может быть присвоен переменной, передан
в качестве аргумента в функцию и т.д.

Свойства объекта можно рассматривать как суб-переменные, переменные, которые являются внутренними для объекта.

## Объект

:navigate projects.code.console

:position 55,30,40,40

### Создание объекта

Создание объекта начинается с ключевого слова ```object```. Определение объекта
закрывается с помощью ```end```:

```
myChair = object
  legs = 4
  color = "белый"
  material = "дерево"
end
```

Скопируйте приведенный выше код. Вы можете изменить свойства и добавить некоторые, чтобы они подходили, например, для вашего стула.

## Доступ к свойствам объекта

:navigate projects.code.console

:position 55,30,40,40

### Доступ к свойствам объекта

После создания объекта вы можете получить доступ к его свойствам следующим образом:

```
myChair.legs
myChair.material
```

Скопируйте приведенный выше пример и посмотрите результат. Вы также можете попробовать другие
свойства.

## Установить свойства объекта

:navigate projects.code.console

:position 55,30,40,40

### Установка свойств объекта

Вы можете изменять свойства и задавать новые свойства для объекта "myChair":

```
myChair.color = "красный"
myChair.wheels = 5
```

Проверьте, как теперь выглядит ваш объект, просто введите:

```
myChair
```

## Установка свойств объекта

:navigate projects.code.console

:position 55,30,40,40

### Другие способы доступа к свойствам объекта

Вы также можете получить доступ к свойствам объекта, используя скобки и строковое значение, содержащее
имя свойства:

```
myChair["цвет"] = "синий"
```

Это также допускается:

```
property_to_change = "цвет"
myChair[property_to_change] = "желтый"
```

Обратите внимание, что в отличие от переменных, свойства могут иметь любое строковое значение, поэтому в их именах допускаются акценты, пробелы или
специальные символы. Таким образом, можно писать:

```
myChair["% of wood"] = 50
```

Из-за того, как работает синтаксический анализ кода, microScript не разрешает написать это:

```
myChair.% of wood = 50 // это не имеет смысла для синтаксического анализатора microScript
```

## Типы свойств

:navigate projects.code.console

:position 55,30,40,40

### Типы свойств

Свойствами объекта может быть любое допустимое значение microScript: строка, число, список, объект, функция.
Давайте продолжим играть с объектами:

```
myRoom = object
  furniture = []
  size = "достаточно большой"
end
```

Теперь мы можем "соединить" наши два объекта:

```
myRoom.furniture.push(myChair)
myChair.location = myRoom
```

## Функция-член

:navigate projects.code.console

:position 55,30,40,40

### Функция-член

Вы можете установить свойство объекта в качестве функции:

```
myRoom.addFurniture = function(piece)
  furniture.push(piece)
end
```

Обратите внимание на то, что когда функция будет вызываться явно *на* объекте, она будет работать
в области видимости объекта. Таким образом, приведенная выше переменная ```furniture``` правильно относится к свойству
```myRoom.furniture```. Давайте вызовем:

```
myRoom.addFurniture(object
  name = "стол"
  legs = 4
end)
```

Теперь мы можем проверить:

```
myRoom.furniture[0]
myRoom.furniture[1]
```


## Итерация

:navigate projects.code.console

:position 55,30,40,40

### Итерация свойств объекта

Вы можете итерировать свойства объекта с помощью цикла ```for``` следующим образом:

```
for prop in myChair
  print(prop + " = " + myChair[prop])
end
```

Приведенный выше код выведет имя и значение всех свойств нашего
объекта, хранящегося в переменной ```myChair```.

## Конец

:navigate projects.code.console

:position 55,30,40,40

### Конец!

Мы подошли к концу этого курса программирования. При поиске более подробной
информации обязательно загляните на вкладку документации microStudio. Вы также можете перезапустить
одно из этих коротких учебных пособий, когда почувствуете в этом необходимость.

Пришло время создать свой первый проект в microStudio! Возможно, вы захотите ознакомиться с учебным пособием
"Первый проект" или посетить раздел "Обзор", чтобы проверить другие проекты и посмотреть, как они
были написаны.